/*
* Copyright (c) 2011 Massimo Cavalleri <massimo.cavalleri@gmail.com>
* Copyright (c) 2011 Mattia Andena <progmat2000@yahoo.it>
* Copyright (c) 2011 Alessandro Ceseno <ing@alexceseno.it>
* Copyright (c) 2003 Luca Lombardi <luca.lombardi@unipv.it>
* Copyright (c) 2003 Paolo Lombardi <paolo.lombardi@unipv.it>
*
* This file is part of TTEI.
*
* TTEI is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* TTEI is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with TTEI.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * <p>Title: Visualizzatore di immagini </p>
 * <p>Description: Scheletro per il corso di elaborazione di immagini </p>
 * <p>Copyright: Copyright (c) 2003, 2011</p>
 * <p>License: GPL </p>
 * <p>Company: Laboratorio di Visione Artificiale </p>
 * @author Luca Lombardi, Paolo Lombardi, Massimo Cavalleri, Mattia Andena, Alessandro Ceseno
 * @version 1.0
 */

import java.awt.*;

public class ImageCanvas extends Canvas {

  static final int MIN_WIDTH = 64;
  static final int MIN_HEIGHT = 64;

  protected Image image;
  protected Dimension size;

  public ImageCanvas(Image img, Dimension dim) {
    super();
    image = img;
    size = dim;
  }

  public Dimension getMinimumSize() {
    return new Dimension(MIN_WIDTH, MIN_HEIGHT);
  }

  public Dimension getPreferredSize() {
    return size;
  }

  public void paint(Graphics g) {
    g.drawImage(image, 0, 0, size.width, size.height, getBackground(), this);
  }

  public void newImage(Image img) {
    image = img;
    repaint();
  }

}
