/*
* Copyright (c) 2011 Massimo Cavalleri <massimo.cavalleri@gmail.com>
* Copyright (c) 2011 Mattia Andena <progmat2000@yahoo.it>
* Copyright (c) 2011 Alessandro Ceseno <ing@alexceseno.it>
* Copyright (c) 2003 Luca Lombardi <luca.lombardi@unipv.it>
* Copyright (c) 2003 Paolo Lombardi <paolo.lombardi@unipv.it>
*
* This file is part of TTEI.
*
* TTEI is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* TTEI is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with TTEI.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * <p>Title: Elaborazione generica di un'immagine</p>
 * <p>Description: Libreria statica con vari metodi di elaborazione</p>
 * <p>Copyright: Copyright (c) 2003, 2011</p>
 * <p>License: GPL </p>
 * <p>Company: Corso di Teoria e Tecnica di Elaborazione di Immagini 2002/03</p>
 * @author Luca Lombardi, Paolo Lombardi, Massimo Cavalleri, Mattia Andena, Alessandro Ceseno
 * @version 1.0
 */


public class Invert {

  private static int w, h;
  
  /*public Invert(int width, int height) {

    this.w = width;
    this.h = height;

  }*/

  public static void invert(int[] in, int[] out, int width, int height)
  {
  	
  	w = width;
    h = height;
  	
    // fa una verifica di errore
    if(in.length != w*h || out.length != w*h)
    {
      System.err.println("Elaboration: le dimensioni delle immagini non sono corrette!");
      return;
    }

    // elabora l'inversione
    for(int i = 0; i < h; i++) 
      for(int j = 0; j < w; j++)
        out[i*w+j] = 255 - in[i*w+j];

    // fine
  }

}