/*
* Copyright (c) 2011 Massimo Cavalleri <massimo.cavalleri@gmail.com>
* Copyright (c) 2011 Mattia Andena <progmat2000@yahoo.it>
* Copyright (c) 2011 Alessandro Ceseno <ing@alexceseno.it>
*
* This file is part of TTEI.
*
* TTEI is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* TTEI is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with TTEI.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
* <p>Title: Implementazione della trasformata di Hough generalizzata </p>
* <p>Description:Pinzatrici, Mouse, gomma, spillatrice </p>
* <p>Copyright: Copyright (c) 2011</p>
* <p>License: GPL </p>
* @author Massimo Cavalleri, Mattia Andena, Alessandro Ceseno
* @version 1.0
*/
class Oggetto
{
 double TabellaR[][];
 int Voti[];
 double Fase[];
 int Modulo[];
 int in[];
 int w,h,ymax,xmax;
 Op FM;   //modulo fase immagine con gli oggetti
 int tuple,VotiMax,VotiMin;

 public Oggetto(int in[], int w, int h)
 {
 	//in matrice che contine i valori dell'immagine con tutti gli oggetti
 	
 	System.out.println("sono in oggetti");
    this.w = w;
    this.h = h;
    Voti = new int[w*h];
    Fase = new double[w*h];
    Modulo = new int[w*h];
    
    this.in = new int[w*h];
    for(int i=0;i<h;i++)
        for(int j=0;j<w;j++)
            this.in[i*w+j] = in[i*w+j];

    FM = new Op( w, h );
    FM.chiamataOp(in, Modulo, 4, "modulo");
    FM.FasePura(in,Fase);
  }

 public void hough( int ogg[], int wO, int hO, int out[], String uscita)
 {
 	 //ogg  la matrice che contiene i valori dell'immagine
 	 //che contiene soltanto l'oggetto da ricercare
 	 
 	 /*for (int i=0; i<hO; i++)
      for (int j=0; j<wO; j++)
       if(ogg[i*wO+j]==235)
       System.out.println(ogg[i*wO+j]);*/
 	 
 	 //costruisce la tabella R
     setTabellaR( ogg, wO, hO );

     for (int i=0;i<w*h;i++)
      {out[i]=0;
       Voti[i]=0;
      }

     System.out.println("ho finito la tabella - R"); 

     for (int i=0; i<h; i++)
      for (int j=0; j<w; j++)
       if(Modulo[i*w+j] > 50)
        {
          for ( int k=0; k < tuple; k++)
           {
           	double rho = TabellaR[k][0];
           	double dir = - Fase[i*w+j] + TabellaR[k][1];
            int xc = (int)(j + rho * Math.cos( dir ));
            int yc = (int)(i - rho * Math.sin( dir ));

            if((yc>=0)&&(xc>=0)&&(yc<h)&&(xc<w))
             Voti[yc*w+xc]++;
           }
        }
        
      System.out.println("ho finito");

      normalizzaVoti();
      
      imageOut(uscita, in, out);

 }

 public void imageOut(String uscita, int in[], int out[])
 {
 	if(uscita.equals("immagine di uscita"))
 	{
 	   for(int i=0;i<h;i++)
        for(int j=0;j<w;j++)
            out[i*w+j] = in[i*w+j];
            
       for (int i = -2; i <= 2; i++) 
        {
		 out[(ymax+i)*w+(xmax+i)] = 0;
		 out[(ymax+i)*w+(xmax-i)] = 0;
	    }
 	}
 	else
 	 if(uscita.equals("spazio dei parametri"))
 	 {
 	   normalizzaVoti();
 	   
 	   //copio nella matrice di uscita lo spazio dei parametri
 	   for(int i=0;i<h;i++)
        for(int j=0;j<w;j++)
            out[i*w+j] = Voti[i*w+j];
 	 }
 	
 }

 public void normalizzaVoti()
 {
 	//normalizza i voti dello spazio dei parametri tra 0 e 255 per essere
 	//visualizzabili
    VotiMax=0;
    VotiMin=0;

    for(int i=0;i<h;i++)
     for(int j=0;j<w;j++)
       if(Voti[i*w+j]>VotiMax)
        { 
          VotiMax = Voti[i*w+j];
          xmax=j;
          ymax=i;
        }

    for(int i=0;i<h;i++)
     for(int j=0;j<w;j++)
      if(Voti[i*w+j]!=0)
        Voti[i*w+j]=(255*(Voti[i*w+j]-VotiMin)/(VotiMax-VotiMin));
 }

 public void setTabellaR( int ogg[], int wO, int hO )
 {
  Op FMO;  //oggetto per il modulo e la fase dell' immagine  dell' oggetto da cercare
  FMO = new Op( wO, hO );
  
  //riempio la matrice MoluloO
  int ModuloO[] = new int[wO*hO];
  FMO.chiamataOp(ogg, ModuloO, 4, "modulo");

  //calcolo quante righe deve avere la tabella R 
  tuple=0;
  for (int i=0; i<hO; i++)
   for (int j=0; j<wO; j++)
    if(ModuloO[i*wO+j] > 50)
     tuple++;
     
  System.out.println("tuple tabella - R: " + tuple);
     
  TabellaR = new double[tuple][3];
  
  //riempio la matrice FaseO richiamando il metodo della classe Op
  double FaseO[] = new double[wO*hO];
  FMO.FasePura(ogg,FaseO);

   //coordinate del punto Po ('centro') 
   double y0 = hO/2;
   double x0 = wO/2;

  //salvataggio dei parametri nella Tabella R
  int v=0;
  for (int i=0; i<hO; i++)
   for (int j=0; j<wO; j++)
    if(ModuloO[i*wO+j] > 50)
     {
      double dx = j-x0;
      double dy = i-y0;
      
      TabellaR[v][0] = Math.sqrt( Math.pow(dx,2) + Math.pow(dy,2) ); //distanza (apotema) => R

      TabellaR[v][1] = FaseO[i*wO+j] - Math.atan2(dy,dx) - Math.PI;  //beta    

      v++;
     }
 }
 

}
