/*
* Copyright (c) 2011 Massimo Cavalleri <massimo.cavalleri@gmail.com>
* Copyright (c) 2011 Mattia Andena <progmat2000@yahoo.it>
* Copyright (c) 2011 Alessandro Ceseno <ing@alexceseno.it>
*
* This file is part of TTEI.
*
* TTEI is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* TTEI is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with TTEI.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
* <p>Title: Visualizzazione un vettore immagine </p>
* <p>Description: classe dedicata alla visualizzazione di s.p. della trasformata
*                 di hough delle rette </p>
* <p>Copyright: Copyright (c) 2011</p>
* <p>License: GPL </p>
* @author Massimo Cavalleri, Mattia Andena, Alessandro Ceseno
* @version 1.0
*/
import java.awt.*;
import javax.swing.*;
import java.awt.image.*;

public class SpView extends JFrame
 {
   
   protected Dimension image_size;

    public SpView(int inputpx[], int w, int h)
     {
       
       image_size = new Dimension(w, h);
       
       setTitle("Spazio Parametri delle Rette");
       setSize(w,h);
       setResizable(false);
       
       //ciclo per portare il vettore con i 4byte nello standard RGB + primo byte trasparenza
       for(int i=0; i< h; i++)
        for(int j=0; j< w; j++)
         inputpx[i*w+j] = ((inputpx[i*w+j] & 255)* 0x00010101) | 0xff000000;

       MemoryImageSource source;
       source = new MemoryImageSource(image_size.width, image_size.height, inputpx, 0, image_size.width);

       Image image;
       image = createImage(source);
       
       ImagePanel p = new ImagePanel(image, image_size);
      
       Container contentPane = getContentPane();
       
       contentPane.add(p);
               
       show();
       
     }
     
}

class ImagePanel extends JPanel
{
	
	protected Image image;
    protected Dimension size;

    public ImagePanel(Image img, Dimension dim) {
      
      image = img;
      size = dim;
    }
    
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		g.drawImage(image, 0, 0, null);
	}
}
